:: http://www.glfw.org/
::
:: Source http://sourceforge.net/projects/glfw/files/glfw/3.0.4/glfw-3.0.4.zip/download
:: prerequisite: none
set CURRENT_SCRIPT_DIR=%~dp0
cd %CURRENT_SCRIPT_DIR%

set OSGEO4W_ROOT=C:\OSGeo4W64
set P=glfw
set V=3.0.4
set B=1

set R=../../release/%P%
mkdir "%R%"

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x64
echo on
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%

cd %CURRENT_SCRIPT_DIR%
wget http://sourceforge.net/projects/%P%/files/%P%/%V%/%P%-%V%.zip/download
if errorlevel 1 (echo Download error & goto exit)

unzip %P%-%V%.zip
if errorlevel 1 (echo Unzip error & goto exit)

mkdir %P%-%V%-build
mkdir %P%-%V%-install

cd %P%-%V%-build
cmake ../%P%-%V% ^
  -G "Visual Studio 10 Win64"^
  -DCMAKE_INSTALL_PREFIX:PATH="%CURRENT_SCRIPT_DIR%\%P%-%V%-install" ^
  -DBUILD_SHARED_LIBS:BOOL="ON"
if errorlevel 1 (echo Configuration error & goto exit)
  
cmake --build . --config Release
if errorlevel 1 (echo Build error & goto exit)

cmake --build . --target INSTALL --config Release
if errorlevel 1 (echo Installation error & goto exit)

cd ..

:: Fix up install tree
mkdir %P%-%V%-install\bin
mv %P%-%V%-install/lib/*.dll  %P%-%V%-install/bin
:: cmake files contains reference to absolute build dir, let's get rid of them
:: TODO : implement correct glfwConfig.cmake and replace existing one
rm -rf %P%-%V%-install/lib/cmake

copy %P%-%V%\COPYING.txt %P%-%V%-%B%.txt

tar -C %P%-%V%-install -cjf "%R%/%P%-%V%-%B%.tar.bz2" bin include lib
tar -C ../.. -cjf "%R%/%P%-%V%-%B%-src.tar.bz2"  osgeo4w\%P%\package.cmd osgeo4w\%P%\setup.hint 
tar -jtf "%R%/%P%-%V%-%B%.tar.bz2" | sed "s@\\\@/@g" | sed "s@//@/@g" > "%R%\%P%-%V%-%B%.manifest"
xcopy setup.hint "%R%"
copy %P%-%V%\COPYING.txt %P%-%V%-%B%.txt
xcopy "%P%-%V%-%B%.txt"  "%R%"



REM devenv glfw-%V%\build\vc10\glew.sln /Build "Release|x64"
REM if errorlevel 1 (echo Build error & goto exit)

REM copy glew-%V%\LICENSE.txt %P%-%V%-%B%.txt

REM set WORK=work
REM mkdir package package\bin package\include package\lib
REM copy glew-%V%\bin\Release\x64\*.* package\bin
REM xcopy /e /s glew-%V%\include\* package\include
REM xcopy glew-%V%\lib\Release\x64\*.lib package\lib

REM tar -C package -cjf "%R%/%P%-%V%-%B%.tar.bz2" bin include lib
REM tar -C ../.. -cjf "%R%/%P%-%V%-%B%-src.tar.bz2"  osgeo4w\%P%\package.cmd osgeo4w\%P%\setup.hint 
REM tar -jtf "%R%/%P%-%V%-%B%.tar.bz2" | sed "s@\\\@/@g" | sed "s@//@/@g" > "%R%\%P%-%V%-%B%.manifest"
REM xcopy setup.hint "%R%"
REM xcopy "%P%-%V%-%B%.txt"  "%R%"

:exit
